package com.pengyifan.biocreativev;

import com.pengyifan.commons.io.BasenameUtils;
import com.pengyifan.kernel.MyProperties;
import com.pengyifan.kernel.allpathgraph.module.DefaultApgConfiguration;
import com.pengyifan.util.PropertiesLoader;
import java.nio.file.Paths;
import java.util.logging.LogManager;

public class PPIExtractorTest {
  public static void main(String args[]) throws Exception {
    LogManager.getLogManager().readConfiguration(
        PropertiesLoader.loadLoggingPropertiesStream());

    if (args.length == 0) {
      args = new String[1];
      args[0] = "aimed";
    }

    //    MyProperties properties = new MyProperties(args[0]);
    //
    //    PPIExtractorBasicBatch s = new PPIExtractorBasicBatch(
    //        new DefaultApgConfiguration(),
    //        BasenameUtils.getTextBasenames(properties.getBratWithNegatives("AIMed.d176.s1492.txt")));
    //    s.bratInputDir = properties.getBratWithNegatives();
    //    s.parsingInputDir = properties.getParsingDir();
    //    s.corefInputDir = properties.getCorefDir();
    //    s.abbrInputDir = properties.getAbbrDir();
    //    s.outputDir = properties.getTempDir().resolve("ppi");
    //    s.triggerFile = properties.getDropboxResourcesDir().resolve("triggers/biocreative-triggers.txt");
    //    s.process();

    MyProperties properties = new MyProperties("biocreative5/dataset");

    PPIExtractorBasicBatch s = new PPIExtractorBasicBatch(
        new DefaultApgConfiguration(),
        BasenameUtils.getTextBasenames(Paths.get("tmp/biocreative5/dataset/brat/12048243_12083.txt")));

    s.bratInputDir = properties.getTempDir().resolve("brat");
    s.parsingInputDir = properties.getTempDir().resolve("ptb2");
    s.outputDir = properties.getTempDir().resolve("ppi");
    s.triggerFile = properties.getDropboxResourcesDir()
        .resolve("triggers/biocreative-triggers.txt");
    s.process();
  }
}
