package com.pengyifan.biocreativev;

import com.pengyifan.bioc.BioCPassage;
import java.util.Optional;

public enum PassageType {
  TITLE, TITLE_1, TITLE_2, ABSTRACT, FIG_CAPTION, FIG_TITLE_CAPTION, UNKNOWN;

  public boolean isTitle() {
    return this == TITLE_1 || this == TITLE_2;
  }

  public static PassageType getPassageType(BioCPassage passage) {
    Optional<String> maybeType = passage.getInfon("type");
    if (!maybeType.isPresent()) {
      return PassageType.UNKNOWN;
    }
    String type = maybeType.get();
    if (type.equalsIgnoreCase("title_1")) {
      return PassageType.TITLE_1;
    } else if (type.equalsIgnoreCase("title_2")) {
      return PassageType.TITLE_2;
    } else if (type.equalsIgnoreCase("abstract")) {
      return PassageType.ABSTRACT;
    } else if (type.equalsIgnoreCase("fig_caption")) {
      return PassageType.FIG_CAPTION;
    } else if (type.equalsIgnoreCase("fig_title_caption")) {
      return PassageType.FIG_TITLE_CAPTION;
    }
    return PassageType.UNKNOWN;
  }
}
