package com.pengyifan.biocreativev;

import com.pengyifan.nlp.trees.TreeUtils;
import edu.stanford.nlp.ling.CoreLabel;
import edu.stanford.nlp.trees.Tree;

import static com.google.common.base.Preconditions.checkArgument;

public class TreeWordSetter {

  private Tree tree;
  private String text;

  public TreeWordSetter(Tree tree, String text) {
    this.tree = tree;
    this.text = text;
  }

  public void set() {
    for (Tree leaf : tree.getLeaves()) {
      CoreLabel label = (CoreLabel) leaf.label();
      //      try {
      String expected = text.substring(label.beginPosition(), label.endPosition());
      String actual = TreeUtils.adaptValue(label.value());
      checkArgument(actual.equals(expected), "Not equal. label[%s %s, %s], expected[%s]",
          actual, label.beginPosition(), label.endPosition(), expected);
      label.setWord(expected);
      //      } catch (StringIndexOutOfBoundsException e) {
      //        System.err.printf("%s [%d, %d]\n%s", label, label.beginPosition(), label.endPosition(), text);
      //        e.printStackTrace();
      //        System.exit(1);
      //      }
    }
  }
}
