package com.pengyifan.biocreativev.cmd;

import com.google.common.collect.Lists;
import com.google.common.collect.Sets;
import com.pengyifan.kernel.MyProperties;
import org.apache.commons.io.FilenameUtils;

import java.nio.file.DirectoryStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Collection;
import java.util.List;
import java.util.Set;

/**
 * Created by pengy6 on 6/11/2015.
 */
public class BiocreativeUtils {
  public static Collection<String> getBioCBasenames(String dataset) {
    List<String> list = Lists.newArrayList();
    MyProperties prop = new MyProperties("biocreative5");
    Path root = prop.getDropboxDir().resolve(dataset).resolve("origin/bioc");
    try (DirectoryStream<Path> stream = Files.newDirectoryStream(root, "*.xml")) {
      for (Path file : stream) {
        String basename = FilenameUtils.getBaseName(file.toString());
        list.add(basename);
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
    list.sort(String::compareTo);
    return list;
  }

  public static Collection<String> getAllTextBasenames(String dataset) {
    List<String> list = Lists.newArrayList();
    MyProperties prop = new MyProperties("biocreative5");
    Path root = prop.getDropboxDir().resolve(dataset).resolve("origin/brat");
    try (DirectoryStream<Path> stream = Files.newDirectoryStream(root, "*.txt")) {
      for (Path file : stream) {
        String basename = FilenameUtils.getBaseName(file.toString());
        list.add(basename);
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
    list.sort(String::compareTo);
    return list;
  }

  public static Collection<String> getTextBasenames(String dataset) {
    Set<String> set = Sets.newHashSet();
    for(String basename: getAllTextBasenames(dataset)) {
        if (basename.indexOf('_') != -1) {
          basename = basename.substring(0, basename.indexOf('_'));
        }
        set.add(basename);
      }

    List<String> list = Lists.newArrayList(set);
    list.sort(String::compareTo);
    return list;
  }

  public static Path getFile(Path dir, String basename, int offset, String ext) {
    return dir.resolve(String.format("%s_%d.%s", basename, offset, ext));
  }
}
