package com.pengyifan.commons.collections.dependencygraph;

public class DependencyGraphUtils {

  // /**
  // * <pre>
  // * (add)
  // * +------------------------+
  // * | |
  // * | v
  // * source source --> source --> target
  // * </pre>
  // */
  // public static int propagateFromSourceSourceToTarget(
  // DependencyGraph graph,
  // DependencyGraphVertex source,
  // DependencyGraphVertex target) {
  // int startIndex = graph.getMaxIndex() + 1;
  // int edgeIndex = startIndex;
  // for (DependencyGraphEdge incomingEdgeOfSource : graph
  // .incomingEdgesOf(source)) {
  // if (incomingEdgeOfSource.getDependency().getName() != DependencyName.NOT_DEP) {
  // continue;
  // }
  // DependencyGraphVertex sourceSource = graph
  // .getEdgeSource(incomingEdgeOfSource);
  // DependencyGraphEdge edge = new DependencyGraphEdge(edgeIndex,
  // incomingEdgeOfSource);
  // if (sourceSource != target
  // && !containsEdge(graph, sourceSource, target, edge)) {
  // graph.addEdge(sourceSource, target, edge);
  // edgeIndex++;
  // }
  // }
  // return edgeIndex - startIndex;
  // }

  /**
   * <pre>
   *       +-----------------------------+
   *       |                             |
   *       |        (add)                v
   * target source -------> source ---> target
   * </pre>
   */
  // public static int propagateFromTargetSourceToSource(
  // DependencyGraph graph,
  // DependencyGraphVertex source,
  // DependencyGraphVertex target) {
  // int startIndex = graph.getMaxIndex() + 1;
  // int edgeIndex = startIndex;
  // for (DependencyGraphEdge incomingEdgeOfTarget : graph
  // .incomingEdgesOf(target)) {
  // if (incomingEdgeOfTarget.getDependency().getName() != DependencyName.NOT_DEP) {
  // continue;
  // }
  // DependencyGraphVertex targetSource = graph
  // .getEdgeSource(incomingEdgeOfTarget);
  // DependencyGraphEdge edge = new DependencyGraphEdge(edgeIndex,
  // incomingEdgeOfTarget);
  // if (targetSource != source
  // && !containsEdge(graph, targetSource, source, edge)) {
  // graph.addEdge(targetSource, source, edge);
  // edgeIndex++;
  // }
  // }
  // return edgeIndex - startIndex;
  // }

  // TODO Remove unused code found by UCDetector
  // /**
  // * <pre>
  // * +-----------------------------+
  // * | |
  // * | (add) v
  // * target source -------> source ---> target
  // * </pre>
  // */
  // public static int propagateFromTargetSourceToSource(
  // DependencyGraph graph,
  // DependencyGraphEdge edge,
  // DependencyGraphVertex source,
  // DependencyGraphVertex target) {
  // int startIndex = graph.getMaxIndex() + 1;
  // int edgeIndex = startIndex;
  // for (DependencyGraphEdge inEdgeOfTarget : graph.incomingEdgesOf(target)) {
  // if (inEdgeOfTarget.getDependency().getName() == DependencyName.NOT_DEP
  // && inEdgeOfTarget.getSemanticName() != edge
  // .getSemanticName()) {
  // DependencyGraphVertex targetSource = graph
  // .getEdgeSource(inEdgeOfTarget);
  // DependencyGraphEdge newEdge =
  // new DependencyGraphEdge(edgeIndex, inEdgeOfTarget);
  // if (targetSource != source
  // && !containsEdge(graph, targetSource, source, newEdge)) {
  // graph.addEdge(targetSource, source, newEdge);
  // edgeIndex++;
  // }
  // }
  // }
  // return edgeIndex - startIndex;
  // }

  // /**
  // * <pre>
  // * (add)
  // * source --> source target <------- target
  // * </pre>
  // */
  // public static int propagateFromTargetToSourceTarget(DependencyGraph graph,
  // DependencyGraphVertex source,
  // DependencyGraphVertex target) {
  // int startIndex = graph.getMaxIndex() + 1;
  // int edgeIndex = startIndex;
  // for (DependencyGraphEdge outgoingEdgeOfSource : graph
  // .outgoingEdgesOf(source)) {
  // if (outgoingEdgeOfSource.getDependency().getName() != DependencyName.NOT_DEP) {
  // continue;
  // }
  // DependencyGraphVertex sourceTarget = graph
  // .getEdgeTarget(outgoingEdgeOfSource);
  // DependencyGraphEdge edge = new DependencyGraphEdge(edgeIndex,
  // outgoingEdgeOfSource);
  // if (sourceTarget != target
  // && !containsEdge(graph, target, sourceTarget, edge)) {
  // graph.addEdge(target, sourceTarget, edge);
  // edgeIndex++;
  // }
  // }
  // return edgeIndex - startIndex;
  // }
  //
  // /**
  // * <pre>
  // * (add)
  // * +-------------------------+
  // * | |
  // * | v
  // * source --> target --> target target
  // * </pre>
  // */
  // public static int propagateFromSourceToTargetTarget(DependencyGraph graph,
  // DependencyGraphVertex source,
  // DependencyGraphVertex target) {
  // int startIndex = graph.getMaxIndex() + 1;
  // int edgeIndex = startIndex;
  // for (DependencyGraphEdge outgoingEdgeOfTarget : graph
  // .outgoingEdgesOf(target)) {
  // if (outgoingEdgeOfTarget.getDependency().getName() != DependencyName.NOT_DEP) {
  // continue;
  // }
  // DependencyGraphVertex targetTarget = graph
  // .getEdgeTarget(outgoingEdgeOfTarget);
  // DependencyGraphEdge edge = new DependencyGraphEdge(edgeIndex,
  // outgoingEdgeOfTarget);
  // if (targetTarget != source
  // && !containsEdge(graph, source, targetTarget, edge)) {
  // graph.addEdge(source, targetTarget, edge);
  // edgeIndex++;
  // }
  // }
  // return edgeIndex - startIndex;
  // }

  // public static Set<DependencyGraphVertex> outgoingEdgesOf(
  // DependencyGraph graph,
  // DependencyGraphVertex v,
  // DependencyName name,
  // String specific) {
  // return graph.outgoingEdgesOf(v, name, specific);
  // }
  //
  // public static Set<DependencyGraphVertex> incomingEdgesOf(
  // DependencyGraph graph,
  // DependencyGraphVertex v,
  // DependencyName name,
  // String specific) {
  // return graph.incomingEdgesOf(v, name, specific);
  // }
  //
  // public static boolean hasOutgoingEdgesOf(DependencyGraph graph,
  // DependencyGraphVertex v,
  // DependencyName name,
  // String specific) {
  // return graph.hasOutgoingEdgesOf(v, name, specific);
  // }
  //
  // public static boolean hasOutgoingEdgesOf(DependencyGraph graph,
  // DependencyGraphVertex v,
  // SemanticName name,
  // String specific) {
  // return graph.hasOutgoingEdgesOf(v, name, specific);
  // }

  // /**
  // * @return the number of added edges
  // */
  // public static int addEdges(DependencyGraph graph,
  // DependencyGraphVertex source, Set<DependencyGraphVertex> targets,
  // DependencyName dependencyName,
  // String dependencySpecific) {
  // int startIndex = graph.getMaxIndex() + 1;
  // int edgeIndex = startIndex;
  // for (DependencyGraphVertex target : targets) {
  // if (target == source) {
  // continue;
  // }
  // DependencyGraphEdge edge = DependencyGraphEdge.of(edgeIndex,
  // dependencyName, dependencySpecific);
  // if (!containsEdge(graph, source, target, edge)) {
  // edgeIndex++;
  // graph.addEdge(source, target, edge);
  // }
  // }
  // return edgeIndex - startIndex;
  // }


  public static boolean containsEdge(DependencyGraph graph,
      DependencyGraphVertex source, DependencyGraphVertex target,
      DependencyGraphEdge expected) {
    for (DependencyGraphEdge edge : graph.getAllEdges(source, target)) {
      if (equals(edge,
          expected.getDependency().getName(),
          expected.getDependency().getSpecific().orElse(null))) {
        return true;
      }
    }
    return false;
  }

  private static boolean equals(DependencyGraphEdge edge,
      DependencyName dependencyName,
      String dependencySpecific) {
    return dependencySpecific == null ?
        edge.getDependency().getName() == dependencyName
        :
        edge.getDependency().equals(dependencyName, dependencySpecific);
  }
}
