package com.pengyifan.commons.nio;

import java.util.Collection;
import java.util.logging.Logger;

public class BatchProcessor {

  private static final Logger logger = Logger.getAnonymousLogger();

  public static void walk(Collection<String> basenames, BasenameVisitor visitor) throws Exception {
    visitor.preprocess();
    for (String basename : basenames) {
      logger.info(String.format("process %s", basename));
      visitor.preprocessFile(basename);
      visitor.processFile(basename);
      visitor.postprocessFile(basename);
    }
    visitor.postprocess();
  }
}
