package com.pengyifan.experimental;

import com.pengyifan.bioc.BioCCollection;
import com.pengyifan.bioc.BioCPassage;
import com.pengyifan.bioc.io.BioCCollectionReader;
import com.pengyifan.bioc.util.BioCPassageIterator;
import org.apache.commons.io.FilenameUtils;

import javax.xml.stream.XMLStreamException;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.DirectoryStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class BioC2Text {
  public static void main(String[] args) throws IOException, XMLStreamException {
    Path dir = Paths.get("tmp/biocreative5/dataset/original");

    for(Path p: Files.newDirectoryStream(dir)) {
      BioCCollectionReader r = new BioCCollectionReader(Files.newBufferedReader(p));
      BioCCollection c = r.readCollection();
      r.close();

      Path o = p.getParent().resolve(FilenameUtils.getBaseName(p.getFileName().toString()) + ".txt");
      BufferedWriter w = Files.newBufferedWriter(o);

      BioCPassageIterator itr = new BioCPassageIterator(c);
      while (itr.hasNext()) {
        BioCPassage passage = itr.next();
        if (passage.getText().isPresent()) {
          w.write(passage.getText().get());
          w.newLine();
        }
      }
      w.close();
    }
  }
}
