package com.pengyifan.kernel;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class MyProperties {

  private final String corpusName;
  public final static String home = System.getProperty("user.home");
  
  public MyProperties() {
    this.corpusName = null;
  }

  public MyProperties(String corpusName) {
    this.corpusName = corpusName;
  }
  
  public Path getTempDir() {
    return Paths.get("tmp", getCorpusName());
  }

  public String getCorpusName() {
    return corpusName;
  }
  
  public Path getDropboxResourcesDir() {
    return Paths.get(home, "Dropbox/Researches/resources");
  }
  
  public Path getDropboxDir() {
    return Paths.get(home, "Dropbox/Researches/data", getCorpusName());
  }

  public Path getBratPositive() throws IOException {
    return createIfNotExist(getTempDir().resolve("brat-positive"));
  }

  private Path createIfNotExist(Path path) throws IOException {
    if (!Files.exists(path)) {
      return Files.createDirectory(path);
    }
    return path;
  }
}
