package com.pengyifan.kernel;

public enum PositiveNegativeStatus {
  POSITIVE(1), NEGATIVE(-1), UNKNOWN(0);

  private final int value;

  private PositiveNegativeStatus(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static PositiveNegativeStatus valueOf(int value) {
    switch (value) {
    case 0:
      return UNKNOWN;
    case 1:
      return POSITIVE;
    case -1:
      return NEGATIVE;
    default:
      throw new IllegalArgumentException("Unknown value: " + value);
    }
  }
}