package com.pengyifan.kernel.allpathgraph.module;

import com.pengyifan.nlp.trees.DependencyType;
import com.pengyifan.nlp.trees.GrammaticalStructureBuilder;
import com.pengyifan.nlp.trees.OffsetTreeTransformer;
import com.pengyifan.nlp.trees.TreeBuilder;
import edu.stanford.nlp.trees.EnglishGrammaticalStructureFactory;

public class DefaultApgConfiguration implements ApgConfiguration {

  @Override
  public DependencyType getDependencyType() {
    return DependencyType.CCprocessed;
  }

  @Override
  public TreeBuilder getTreeBuilder() {
    return new TreeBuilder(OffsetTreeTransformer.treeTransformer());
  }

  @Override
  public GrammaticalStructureBuilder getGrammaticalStructureBuilder() {
    return new GrammaticalStructureBuilder(
        new EnglishGrammaticalStructureFactory());
  }

}
