package com.pengyifan.kernel.allpathgraph.singleprocess;

import com.pengyifan.commons.collections.dependencygraph.DependencyGraph;
import com.pengyifan.commons.collections.dependencygraph.DependencyGraphVertex;
import com.pengyifan.nlp.process.ExtractLemma;

/**
 * Set DependencyGraphVertex lemma.
 */
public class LemmaSetter {

  private final DependencyGraph graph;
  private static final ExtractLemma LEMMA = new ExtractLemma();

  public LemmaSetter(DependencyGraph graph) {
    this.graph = graph;
  }

  public void set() {
    for (DependencyGraphVertex vertex : graph.vertexSet()) {
      String lemma = LEMMA.lemmatize(vertex.getWord(), vertex.getTag().toString());
      vertex.setLemma(lemma);
    }
  }
}
