package com.pengyifan.nlp.ling.verb;

import com.google.common.collect.Sets;
import com.pengyifan.kernel.MyProperties;
import java.io.IOException;
import java.nio.file.Files;
import java.util.Set;

public class VerbUtils {

  public static final MyProperties PROPERTIES = new MyProperties();

  public static final Set<String> vion = getDic("vion.txt");
  public static final Set<String> vnorm = getDic("vnorm.txt");
  public static final Set<String> jjed = getDic("jjed.txt");
  public static final Set<String> jjing = getDic("jjing.txt");
  public static final Set<String> between = getDic("between.txt");

  private static Set<String> getDic(String filename) {
    try {
      return Sets.newHashSet(Files.readAllLines(PROPERTIES
          .getDropboxResourcesDir().resolve("dict").resolve(filename)));
    } catch (IOException e) {
      e.printStackTrace();
    }
    return Sets.newHashSet();
  }

  public static boolean isVnorm(String s) {
    return vnorm.contains(s.toLowerCase());
  }

  public static boolean isBetween(String s) {
    return between.contains(s.toLowerCase());
  }

  public static boolean isActiveVerb(String tag) {
    return getVerbVoice(tag) == VerbVoice.ACTIVE;
  }

  public static VerbVoice getVerbVoice(String tag) {
    switch (tag) {
    case "VB":
    case "VBZ":
    case "VBD":
    case "VBP":
    case "VBG":
      return VerbVoice.ACTIVE;
    case "VBN":
      return VerbVoice.PASSIVE;
    default:
      return VerbVoice.UNKNOWN;
    }
  }

  public boolean isVerb(String tag) {
    switch (tag) {
    case "VB":
    case "VBZ":
    case "VBD":
    case "VBP":
    case "VBG":
    case "VBN":
    case "TO":
    case "MD":
      return true;
    default:
      return false;
    }
  }

  public static boolean isVion(String lemma) {
    return vion.contains(lemma);
  }
}
