package com.pengyifan.bionlpst.trigger;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.io.IOException;
import java.net.URISyntaxException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;

import org.junit.Test;

public class TriggerReaderTest {

  private static final String TRIGGER_FILENAME = "sample-triggers.txt";

  @Test
  public void testReadAll()
      throws IOException, URISyntaxException {

    TriggerReader reader = new TriggerReader(getReader());
    List<Trigger> triggers = reader.readAll();
    reader.close();

    assertEquals(6, triggers.size());
    assertEquals("Binding", triggers.get(1).getType());
    assertEquals("interaction", triggers.get(2).getWord());
    assertEquals("NNS", triggers.get(3).getTag());
    assertEquals(10, triggers.get(4).getFrequency().get().intValue());
    assertEquals("Arg Vnorm", triggers.get(5).getPatterns().get(1));
  }

  private Path getReader() throws URISyntaxException {
    assertNotNull("Test file missing",
        getClass().getResource("/" + TRIGGER_FILENAME));
    return Paths.get(getClass().getResource("/" + TRIGGER_FILENAME).toURI());
  }
}
