package com.pengyifan.bionlpst.trigger;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import com.google.common.testing.EqualsTester;

public class TriggerTest {

  private static final Trigger base = new Trigger()
      .setFrequency(0)
      .setMark("mark")
      .setTag("tag")
      .setType("type")
      .setWord("word");

  @Test
  public void test_allField() {
    assertEquals(0, base.getFrequency().get().intValue());
    assertEquals("mark", base.getMark().get());
    assertEquals("tag", base.getTag());
    assertEquals("type", base.getType());
    assertEquals("word", base.getWord());
  }

  @Test
  public void testEqualsObject() {
    Trigger diffFreq = copy(base).setFrequency(1);
    Trigger diffMark = copy(base).setMark("mark2");
    Trigger diffTag = copy(base).setTag("tag2");
    Trigger diffType = copy(base).setType("type2");
    Trigger diffWord = copy(base).setWord("word2");
    new EqualsTester()
        .addEqualityGroup(base)
        .addEqualityGroup(diffFreq)
        .addEqualityGroup(diffMark)
        .addEqualityGroup(diffTag)
        .addEqualityGroup(diffType)
        .addEqualityGroup(diffWord)
        .testEquals();
  }

  private Trigger copy(Trigger trigger) {
    return new Trigger()
        .setFrequency(trigger.getFrequency().get())
        .setMark(trigger.getMark().get())
        .setTag(trigger.getTag())
        .setType(trigger.getType())
        .setWord(trigger.getWord());
  }
}
