package com.pengyifan.commons.batch;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.io.File;
import java.io.IOException;
import java.util.List;

import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.TemporaryFolder;

import com.pengyifan.commons.io.BasenameUtils;

public class BasenameFilterUtilsTest {

  @Rule
  public TemporaryFolder testFolder = new TemporaryFolder();

  public void setUp()
      throws IOException {
  }

  @Test
  public void testGetTextBasenameFromDir()
      throws IOException {
    testFolder.newFile("a1.txt");
    testFolder.newFile("a2.txt");
    testFolder.newFile("a3.txt");
    List<String> basenames = BasenameUtils.getTextBasenames(
        testFolder
            .getRoot().toPath());
    assertEquals(3, basenames.size());
    assertEquals("a1", basenames.get(0));
    assertEquals("a2", basenames.get(1));
    assertEquals("a3", basenames.get(2));
  }

  @Test
  public void testGetTextBasenameFromDir_file()
      throws IOException {
    File a1 = testFolder.newFile("a1.txt");
    testFolder.newFile("a2.txt");
    testFolder.newFile("a3.txt");
    List<String> basenames = BasenameUtils.getTextBasenames(
        a1.toPath());
    assertEquals(1, basenames.size());
    assertEquals("a1", basenames.get(0));
  }

  @Test
  public void testGetTextBasenameFromDir_empty()
      throws IOException {
    File a1 = testFolder.newFile("a1.java");
    testFolder.newFile("a2.txt");
    testFolder.newFile("a3.txt");
    List<String> basenames = BasenameUtils.getTextBasenames(
        a1.toPath());
    assertTrue(basenames.isEmpty());
  }
}
