package com.pengyifan.util;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.nio.charset.StandardCharsets;
import java.util.Properties;

import org.apache.commons.configuration.ConfigurationConverter;
import org.apache.commons.configuration.ConfigurationException;
import org.apache.commons.configuration.PropertiesConfiguration;
import org.junit.Test;

public class PropertiesTest {

  private static final String PROPERTIES_FILENAME = "sample.properties";

  @Test
  public void test() throws ConfigurationException {
    Properties prop = getProperties();
    assertEquals("Localization", prop.getProperty("event.type"));
    assertEquals("Localization-triggers.txt", prop.getProperty("trigger.file"));
    assertEquals("/train-Localization.label", prop.getProperty("label.file"));
  }

  private Properties getProperties()
      throws ConfigurationException {
    assertNotNull("Test file missing",
        getClass().getResource("/" + PROPERTIES_FILENAME));
    PropertiesConfiguration config = new PropertiesConfiguration();
    config.load(getClass().getResourceAsStream(
        "/" + PROPERTIES_FILENAME), StandardCharsets.UTF_8.name());
    return ConfigurationConverter.getProperties(config);
  }
}
